C An and Bn in Mie Calculation
C BASED ON Ulaby, Moore, and Fung (1981)

        SUBROUTINE ABSUB(F,T,R,A,B,NR,NAB,NABR,MIXING)
   
C R --- RADIUS OF DROPS IN UM,>0 WATER <0 ICE =0 NONE
C NR -- DROP'S CATE.
C NAB --- NUMBERS OF ORDER
C A --- A(NR,N) B(NR,N)  A&B
C NABR(NR) --- How many term for adding. for larger drop, bigger.
C              2*X+10
C F --- frequency in GHz
C T  --- Temperature in K 

       REAL R(*)
       CHARACTER*(*) MIXING
       INTEGER NABR(*)
       COMPLEX A(NR,*),B(NR,*),M,MTMP
       COMPLEX*16 MX,COMI,DM
       COMPLEX*16 A0,A1,W9,W0,W1,P1,P2,BB1,BB2
       REAL*8  X, R1, R2, DI

       COMI=(0.0D0,1.0D0)
       C=30./F
       PAI=3.1415926
       DPI=0.916

       DO I=1,NR
       DO J=1,NAB
        A(I,J)=(0.0,0.0)
        B(I,J)=(0.0,0.0)
       END DO
       END DO

       DO 11 J=1,NR
        R0=INT(ABS(-R(J)))
	NABR(J)=0
	if(R0.eq.0.) GOTO 11

        IF (R(J).GT.0.) THEN
         CALL mwater(F,T,M)
        ELSE
         DICE=-(R(J)+R0)
	 CALL mice(F,T,M)
	 IF(DICE.GE.DPI) GOTO 20
 
        IF(MIXING.EQ."MG" .OR. MIXING.EQ."mg") THEN

c  Maxwell-Garnet Mixing rule
 
 	 M=M*M
 	 VI=DICE/DPI
 	 VA=1-VI
 	 MTMP=2*M/(1-M)*(1/(1-M)*CLOG(1/M)-1)
 	 M=CSQRT((VI*M+VA*MTMP)/(VI+MTMP*VA))
         
        ELSE IF(MIXING.EQ."EV" .OR. MIXING.EQ."ev") THEN

c  equivalent volumn rule
c  consider as a solid sphere with the same mass
 
         R0=(DICE/DPI)**(1./3.)*R0
 
        ELSE IF(MIXING.EQ."LL" .OR. MIXING.EQ."ll" .OR.
     1         MIXING.EQ."DB" .OR. MIXING.EQ."db") THEN

c  Debye rule - Ks/rous = Ki/roui 
c  Also called Lorentz-Lorenz mixing rule

	 MTMP=(M*M-1)/(M*M+2)*DICE/DPI
	 M=CSQRT((1+2*MTMP)/(1-MTMP))

        ELSE IF(MIXING.EQ."EM" .OR. MIXING.EQ."em" .OR.
     1          MIXING.EQ."BR" .OR. MIXING.EQ."br") THEN
       
c Effective medium (Bruggeman) role, which is identical to
c Polder/Santen role (see Bohren&Battan,1980,JAS,1821-)
c
	 M=M*M
	 MTMP=3*(1-DICE/DPI)*(M-1)-2*M+1
	 M=CSQRT((-MTMP+CSQRT(MTMP**2+8*M))/4)

        ELSE
C default Maxwell-Garnet

 	 M=M*M
 	 VI=DICE/DPI
 	 VA=1-VI
 	 MTMP=2*M/(1-M)*(1/(1-M)*CLOG(1/M)-1)
 	 M=CSQRT((VI*M+VA*MTMP)/(VI+MTMP*VA))         

        ENDIF

        END IF
 20     CONTINUE

	X=2*PAI*R0/C*1.D-4

c       determine how many terms to add (Wiscombe 1979)

	if(X.LT.8.) then
		NWiscombe=X+4*X**(1./3.)+1
	else
		NWiscombe=X+4.05*X**(1./3.)+2
	endif

	MAXTERM=MIN(NAB-1,NWiscombe)

C	
	DM=DCMPLX(M)
        MX=DM*X
	R1=DCOS(X)
	R2=DSIN(X)
        W9=DCMPLX(R1,-R2)
        W0=DCMPLX(R2,R1)
c       A0=CCOS(MX)/CSIN(MX)
	A0=COMI*(1.D0+CDEXP(-2.D0*COMI*MX))/(1.D0-CDEXP(-2.D0*COMI*MX))

       DO 10 I=1,MAXTERM

	DI=I
        W1=(2.D0*DI-1.D0)/X*W0-W9
        A1=-DI/MX+1.D0/(DI/MX-A0)
        P1=A1/DM+DI/X
        P2=DM*A1+DI/X
        R1=DREAL(W1)
        R2=DREAL(W0)
        BB1=P1*W1-W0
        BB2=P2*W1-W0

        A(J,I) = CMPLX( (P1*R1-R2)/BB1 )
        B(J,I) = CMPLX( (P2*R1-R2)/BB2 )

        A0=A1
	W9=W0
	W0=W1

 10    CONTINUE
 	NABR(J)=MAXTERM

c	print*,abs(A(J,MAXTERM))**2+abs(B(J,MAXTERM))**2,X,MAXTERM,F,T

 11    CONTINUE
  
       RETURN
       END
