CALCULATE backscattering cross section
C for spheres
C BASED ON MIE THEORY --- BOHREN and HUFFMAN (1983)
C
	SUBROUTINE bcsdrp(F,NR,BCS,A,B,NABR)
	PARAMETER(PAI=3.1415926)
C 
C  F ---- Frequency in GHz 
C  BCS --- BCS(*) BACKSCATTER CROSS-SECTION, m**2
C  NR --- number of drops
C                 
       REAL BCS(*)
       COMPLEX A(NR,*),B(NR,*),S
       INTEGER NABR(*)
      
       C=30.0/F*1.E-2

       DO 1000 I=1,NR
	   
C  BACKSCATTER
       S=(0.0,0.0)
       DO J=1,NABR(I)
       S=S+(-1)**J*(2*J+1)*(A(I,J)-B(I,J))
       END DO
       BCS(I)=(CABS(S))**2*C*C/4/PAI

 1000  CONTINUE

       RETURN
       END
