CALCULATE ABS, SCAT, EXT CROSS Sections and ASYMMETRY FACTOR
C for spheres
C BASED ON MIE THEORY --- BOHREN and HUFFMAN (1983)
C
	SUBROUTINE csdrp(F,NR,CS,G,A,B,NABR)
	PARAMETER(PAI=3.1415926,SMALL=1.E-32)
C 
C  F ---- Frequency in GHz 
C  CS --- CS(2,*) 1ST ABSORP. 2ND SCATTER, m**2
C  G  --- G(*), Asymmetry Factor
C  NR --- number of drops
C                 
       REAL CS(2,*),G(*)
       COMPLEX A(NR,*),B(NR,*)
       INTEGER NABR(*)
      
       C=30.0/F*1.E-2

       DO 1000 I=1,NR
	   
C  SCATTER
       S=0.0
       DO J=1,NABR(I)
       S=S+(2*J+1)*((CABS(A(I,J)))**2+(CABS(B(I,J)))**2)
       END DO
       S=S*C*C/2/PAI
       CS(2,I)=S
C  ASYMMETRY FACTOR
       S=0.0
       IF(NABR(I).GT.0 .and. CS(2,I).GT.SMALL) THEN 
       DO J=1,NABR(I)
        PP=J*(J+2.)/(J+1.)*REAL(A(I,J)*CONJG(A(I,J+1))+B(I,J)*
     &   CONJG(B(I,J+1)))+(2*J+1.)/J/(J+1.)*REAL(A(I,J)*
     &   CONJG(B(I,J)))
	S=S+PP
       END DO
       S=S*C*C/PAI/CS(2,I)
       ENDIF
       G(I)=S
C  EXTINCTION
       S=0.0
       DO J=1,NABR(I)
       S=S+(2*J+1)*REAL(A(I,J)+B(I,J))
       END DO
       S=S*C*C/2/PAI
C  ABSORP.
       CS(1,I)=S-CS(2,I)

 1000  CONTINUE

       RETURN
       END
