CALCULATE ABS, SCAT, EXT CROSS Sections and ASYMMETRY FACTOR
C for nonspherical ice particles
C BASED ON  DDA CALCULATIONS (Liu, 2004)
C
	SUBROUTINE cspar(F,T,NSHAPE,R0,NUM,CS,G,DEN,IO)
	PARAMETER(DPI=0.916)
C 
C  F ---- Frequency in GHz
C  T ---- Temperature in K
C  NSHAPE - ICE SHAPE NUMBER (0 - 10)
C  CS --- CS(2,*) 1ST ABSORP. 2ND SCATTER.
C         m^2
C  G  --- G(*), Asymmetry Factor
C  R0 --- R(*), 1/2 of maximum dimension, um 
C  NUM --- total number of particles
C DEN --- DEN(*) calculated density (output)
C                 
       REAL CS(2,*),G(*),DEN(*),R0(*),p(50)
       REAL DMAX,ca,cb,csc,g0,re,t000
       INTEGER NSHAPE,IO

       t000=T
       if(T.lt.233.15) t000=233.15

       DO 1000 I=1,NUM

       DMAX=2*R0(I)
       CALL scatdb(F,t000,NSHAPE,dmax,ca,csc,cb,g0,p,re,ind,IO)
C  SCATTER
       CS(2,I)=csc
C  ASYMMETRY FACTOR
       G(I)=g0   
C  ABSORP.
       CS(1,I)=ca
C  DENSITY
       DEN(I)=8*DPI*re**3/dmax**3

 1000  CONTINUE

       RETURN
       END
