	SUBROUTINE DIFEMIS(F,TS,IS,S,WND,DIF_EMIS)
	REAL MU(16), WTS(16),RVH(16,2)

        CALL GAUSQU2 (16,MU,WTS)
	CALL RSURF(F,TS,IS,S,WND,MU,16,RVH)
        DIF_EMIS = 0.0
        DO 200 J = 1, 16
	  EV=1.0-RVH(J,1)
	  EH=1.0-RVH(J,2)
          DIF_EMIS = DIF_EMIS + (EV+EH)*MU(J)*WTS(J)
200     CONTINUE

	RETURN
	END

      SUBROUTINE FRESNEL (COSI, INDEX, EH, EV)
      COMPLEX  INDEX
      REAL     COSI, EH,EV
      COMPLEX  EPSILON, D, RH, RV

      EPSILON = INDEX**2
      D = CSQRT(EPSILON - 1.0 + COSI**2)
      RH = (COSI - D) / (COSI + D)
      RV =(EPSILON*COSI - D) / (EPSILON*COSI + D)
      EH = 1.0 - CABS(RH)**2
      EV = 1.0 - CABS(RV)**2

      RETURN
      END

      SUBROUTINE GAUSQU2 (N, XA, WT)
C        Generates the abscissas (X) and weights (W) for an N point
C      Gauss-Legendre quadrature.  
      INTEGER  N
      REAL     XA(*), WT(*)
      INTEGER  K, I, J, L
      REAL*8   X, XP, PL, PL1, PL2, DPL, TINY
      PARAMETER (TINY=3.0D-7)

      K = (N+1)/2
      DO 130 J = 1, K
        X = COS(3.141592654*(J-.25)/(N+.5))
        I = 0
100     CONTINUE
          PL1 = 1
          PL = X
          DO 120 L = 2, N
            PL2 = PL1
            PL1 = PL
            PL = ( (2*L-1)*X*PL1 - (L-1)*PL2 )/L
120       CONTINUE
          DPL = N*(X*PL-PL1)/(X*X-1)
          XP = X
          X = XP - PL/DPL
          I = I+1
        IF (ABS(X-XP).GT.TINY .AND. I.LT.10) GO TO 100
        XA(J)     = (1-X)/2
        XA(N-J+1) = (1+X)/2
        WT(J  )   = 1.0D0/((1.0D0-X*X)*DPL*DPL)
        WT(N-J+1) = WT(J)
130   CONTINUE

      RETURN
      END
