C*******************i************
C*       SET sphere DROPS       *
C********************************
      SUBROUTINE DRP(R,RN,RR,RG,RGR,WR,WG,WC,Pfac)
      INCLUDE '../include/mwrt.inc'
      REAL R(*),RN(*),R0(NTDRP)

C  INPUTS:
C  RGR: THE DENSITY FOR GRAUPEL (G/CM3)
C  RR : RAINFALL RATE (MM/HR), negative if use WR 
C  WR : rain water content, g/m3, not used if RR>0
C  RG : Graupel Precip RATE (MM/HR), negative if use WG
C  WG : Graupel water content, g/m3, not used if WG>0
C  WC : CLOUD LIQUID WATER CONTENT (G/M3)
C  Pfac: (p0/p)**0.4
C output:
C R - particle size in um, for graupel: R=-r-density
C RN - n(r)dr 1/m3

C     CLOUD WATER
      DO I=NC1,NC2
        R(i)=0
        RN(i)=0
	R0(i)=RZ(i)
      ENDDO
      IF(WC.GT.0.0) THEN
        n=1+NC2-NC1
        call cldwtr(n,R0(NC1),R(NC1),RN(NC1),WC)
      END IF

C     RAIN [M-P]
      DO I=NR1,NR2
        R(i)=0
        RN(i)=0
        R0(i)=RZ(i)
      ENDDO
      IF(RR.GT.0. .or. WR.GT.0.) THEN
       n=1+NR2-NR1
       call rain(n,R0(NR1),R(NR1),RN(NR1),RR,WR,Pfac)
      END IF

C     Graupel
      DO I=NG1,NG2
        R(i)=0
        RN(i)=0
        R0(i)=RZ(i)
      ENDDO
      IF(RG.GT.0.0 .or. WG.GT.0.) THEN 
       IF(RGR.LE.0.0) then
	RGR_Z=Def_DGRP
       ELSE
	RGR_Z=RGR
       ENDIF
       n=1+NG2-NG1
       call graupel(n,R0(NG1),R(NG1),RN(NG1),RGR_Z,RG,WG,DPI,Pfac)
      END IF

      RETURN
      END
