Calculate Gaussian Quadrature and Weights for:
C    Integeral of f(x) from X1 to X2
C    adopted from numerical recipes

	subroutine gauleg(x1,x2,x,w,n)
c
c given the lower and upper limits of integeration x1 and x2, and given n, 
c this routine returns array X and W of length n, containing the abscissas
c and weights of the Gauss-Legendre N-point quadrature formula

	implicit real*8 (A-H,O-Z)
	real x1,x2,x(*),w(*)
	parameter(eps=3.d-14)

	m=(n+1)/2
	xm=0.5d0*(x2+x1)
	xl=0.5d0*(x2-x1)

	do i=1,m
	 z=cos(3.141592654d0*(i-0.25d0)/(N+0.5d0))
 1       continue
	  p1=1.d0
	  p2=0.d0
	  do j=1,n
	   p3=p2
	   p2=p1
           p1=((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
	  end do
	  pp=n*(z*p1-p2)/(z*z-1.d0)
	  z1=z
	  z=z1-p1/pp
	  if(abs(z-z1).gt.eps) goto 1
	  x(i)=xm-xl*z
	  x(n+1-i)=xm+xl*z
	  w(i)=2.d0*xl/((1.d0-z*z)*pp*pp)
	  w(n+1-i)=w(i)
	end do

	return
	end

