C***************************************
C*       SET irregular particles       *
C***************************************
      SUBROUTINE PAR(R,RN,RS,WS,WI,ICEMODEL,SNWMODEL,DEN,Pfac)
      INCLUDE '../include/mwrt.inc'
      REAL R(*),RN(*),R0(NTDRP),DEN(*)
      CHARACTER*(*) ICEMODEL,SNWMODEL

C  INPUTS:
C  RS : SNOWFALL RATE (MM/HR), negative if use WS
C  WS : snow water content, g/m3, not used if WS>0
C  WI : CLOUD ICE WATER CONTENT (G/M3)
C  ICEMODEL: "TROPICS"/"tropics", "MIDLAT"/"midlat"
C  SNWMODEL: "SS"/"ss", "GM"/"gm"
C  DEN - density of ice/snow particles
C  Pfac: (p0/p)**0.4
C output:
C R - particle size in um, for ice: R=-r-density
C RN - n(r)dr 1/m3

C     ICE CLOUD
      DO I=NI1,NI2
	R(i)=0
	RN(i)=0
	R0(i)=RZ(i)
      ENDDO
      IF(WI.GT.0.) THEN
       n=1+NI2-NI1
       call cldice(n,R0(NI1),R(NI1),RN(NI1),ICEMODEL,WI,DEN(NI1))
      ENDIF

C     SNOWFALL
      DO I=NS1,NS2
        R(i)=0
        RN(i)=0
        R0(i)=RZ(i)
      ENDDO
      IF(RS.GT.0.0 .or. WS.GT.0.) THEN
       n=1+NS2-NS1
       call snow(n,R0(NS1),R(NS1),RN(NS1),RS,WS,DEN(NS1),SNWMODEL,Pfac)
      END IF

      RETURN
      END
