C*********************************************
C*       CALCULATE Rainrate if not Given     *
C*********************************************
      REAL FUNCTION RR_CAL(R,RN,Pfac)
      INCLUDE '../include/mwrt.inc'
      REAL R(*),RN(*)

C  INPUTS:
C R - particle size in um
C RN - n(r)dr 1/m3
C  OUTPUT
C Pfac --- (p0/p)^0.4
C RR_CAL -- calculated rainrate, mm h-1
 
      P=3.1415926*4/3.
      RR_CAL=0
      DO I=NR1,NR2
        A=P*(R(I)*1.E-6)**3
        RR_CAL=RR_CAL+A*RN(I)*VR(R(I),Pfac)
      END DO
      RR_CAL=RR_CAL*3.6E6      
 
      RETURN
      END
