C*********************************************
C*       CALCULATE TOTAL WATER CONTENT       *
C*********************************************
      SUBROUTINE TOTW(R,RN,WW1,WW2)
      INCLUDE '../include/mwrt.inc'
      REAL R(*),RN(*)

C  INPUTS:
C R - particle size in um, for graupel: R=-r-density
C RN - n(r)dr 1/m3
C  OUTPUT
C WW1: integrated liquid water content (g/m3)
C WW2: integrated ice water content (g/m3)

      P=3.1415926*4/3.
      WW1=0
      DO I=NC1,NC2
        A=P*(R(I)*1.E-4)**3
        WW1=WW1+A*RN(I)
      END DO
      DO I=NR1,NR2
        A=P*(R(I)*1.E-4)**3
        WW1=WW1+A*RN(I)
      END DO
      WW2=0
      DO I=NI1,NI2
        IF(RN(I).GT.0.0) THEN
        ARR=INT(-R(I))*1.E-4
        DENSITY=-(INT(-R(I))+R(I))
        A=P*ARR**3*DENSITY
        WW2=WW2+A*RN(I)
        END IF
      END DO
      DO I=NS1,NS2
        IF(RN(I).GT.0.0) THEN
        ARR=INT(-R(I))*1.E-4
        DENSITY=-(INT(-R(I))+R(I))
        A=P*ARR**3*DENSITY
        WW2=WW2+A*RN(I)
        END IF
      END DO
      DO I=NG1,NG2
        IF(RN(I).GT.0.0) THEN
        ARR=INT(-R(I))*1.E-4
        DENSITY=-(INT(-R(I))+R(I))
        A=P*ARR**3*DENSITY
        WW2=WW2+A*RN(I)
        END IF
      END DO
 
      RETURN
      END
