C get tb
C 2001.2.22 Add lambertian surface
C 

	SUBROUTINE GETTB(L,F,TS,RS,FoL,RSUU,AL,OM,B0,B1,PJ,
     &                 NS,NL,K,GIJ,TAU,TB,AX,BX,WK,LOUT,U0)
        COMMON /strm4/AJ(2),UI(2)
	PARAMETER(KU=5,KL=5,LDAX=2*KL+KU+1)

	REAL TAU(*),K(NS,*),GIJ(NS*2,NS,*),RS(*),OM(*),
     &            TB(*),AX(LDAX,*),BX(*),B0(*),B1(*),PJ(2*NS,*)
	DIMENSION WK(*),AL(0:NL+1,*),PL(0:4,6),A4(4),GI(4),WKA(2)
	CHARACTER FoL
	LOGICAL FresnelORLambertian
	DATA FresnelORLambertian/.true./        ! default=fresnel

	IX(I)=I+NS-(I/(NS+1))*(NS*2)
	YIJ(I,J,N,X)=0.5*(GIJ(I,J,N)*exp(-K(J,N)*X)+
     1      GIJ(IX(I),J,N)*exp(-K(J,N)*(TAU(N)-X)))
        ZIJ(I,J,N,X)=0.5*(GIJ(I,J,N)*exp(-K(J,N)*X)-
     1      GIJ(IX(I),J,N)*exp(-K(J,N)*(TAU(N)-X)))

	IROW(I,J)=KL+KU+1+I-J

	IF(FoL.EQ."L" .OR. FoL.EQ."l") 
     1               FresnelORLambertian = .false.

	DO I=1,NS
	 A4(I)=AJ(I)
	 A4(I+NS)=AJ(I)
	END DO
	U=ABS(U0)

	NU=NS*2
	NP=NU*L
 	BI0=BWT(F,3.0)
 	BIS=BWT(F,TS)
	
	DO I=1,LDAX
	DO J=1,NP
	AX(I,J)=0.0
	END DO
	END DO

c  RIGHT SIDE
	DO I=1,NS
	 BX(I)=BI0 - PJ(I+NS,1) 
	END DO
	DO J=1,L-1
	DO I=1,NU
	 KI=NS+(J-1)*NU+I
	 BX(KI)= PJ(I,J+1)-(PJ(I,J)+B1(J)*TAU(J))
	END DO
	END DO

	IF (FresnelORLambertian) THEN

	DO I=1,NS
	 BX(NS+(L-1)*NU+I)=(1-RS(I))*BIS
     1                     +RS(I)*(PJ(I+NS,L)+B1(L)*TAU(L))
     1                     -(PJ(I,L)+B1(L)*TAU(L))
	END DO

	ELSE

	 WKA(1)=0.0
	 DO I=1,NS
	 WKA(1)=WKA(1)+PJ(I+NS,L)*UI(I)*AJ(I)
	 END DO
	 DO I=1,NS
	 BX(NS+(L-1)*NU+I)=(1-RS(1))*(BIS-B1(L)*TAU(L))
     1                     -PJ(I,L)+2*RS(1)*WKA(1)

c	 print*,2*RS(1)*WKA(1),RS(I)*PJ(I+NS,L)
	 END DO

	END IF

c LEFT SIDE COMPACKED FORM FOR BANDED SOLVER

	DO I=1,NS
	DO J=1,NS 
	 AX(IROW(I,J),J)=YIJ(I+NS,J,1,0.0)
	 AX(IROW(I,J+NS),J+NS)=ZIJ(I+NS,J,1,0.0)
        END DO
        END DO

	DO N=1,L-1
	DO I=1,NS
	KI=NS+(N-1)*NU+I
	DO J=1,NS
	 KJ=(N-1)*NU+J
	 AX(IROW(KI,KJ),KJ)=YIJ(I,J,N,TAU(N))
	 AX(IROW(KI,KJ+NS),KJ+NS)=ZIJ(I,J,N,TAU(N))
	 AX(IROW(KI,KJ+NU),KJ+NU)=-YIJ(I,J,N+1,0.0)
	 AX(IROW(KI,KJ+3*NS),KJ+3*NS)=-ZIJ(I,J,N+1,0.0)
         AX(IROW(KI+NS,KJ),KJ)=YIJ(I+NS,J,N,TAU(N))
         AX(IROW(KI+NS,KJ+NS),KJ+NS)=ZIJ(I+NS,J,N,TAU(N))
         AX(IROW(KI+NS,KJ+NU),KJ+NU)=-YIJ(I+NS,J,N+1,0.0)
         AX(IROW(KI+NS,KJ+3*NS),KJ+3*NS)=-ZIJ(I+NS,J,N+1,0.0)
        END DO
	END DO
	END DO

	DO I=1,NS
	KI=NS+(L-1)*NU+I

	IF (FresnelORLambertian) THEN

	DO J=1,NS
	 KJ=(L-1)*NU+J
	 AX(IROW(KI,KJ),KJ)=YIJ(I,J,L,TAU(L))-RS(I)*YIJ(I+NS,J,L,TAU(L))
	 AX(IROW(KI,KJ+NS),KJ+NS)=ZIJ(I,J,L,TAU(L))
     1                            -RS(I)*ZIJ(I+NS,J,L,TAU(L))
        END DO

	ELSE
! corrected 2014/12/30
	DO J=1,NS
	WKA(1)=0.0
	WKA(2)=0.0
	DO KK=1,NS
	 WKA(1)=WKA(1)+YIJ(KK+NS,J,L,TAU(L))*UI(KK)*AJ(KK)
	 WKA(2)=WKA(2)+ZIJ(KK+NS,J,L,TAU(L))*UI(KK)*AJ(KK)
	ENDDO
!	DO J=1,NS
	 KJ=(L-1)*NU+J
	 AX(IROW(KI,KJ),KJ)=YIJ(I,J,L,TAU(L))-2*RS(1)*WKA(1)
	 AX(IROW(KI,KJ+NS),KJ+NS)=ZIJ(I,J,L,TAU(L))-2*RS(1)*WKA(2)
	END DO

	END IF

c	print*, RS(1),RS(2)
c	print*,2*RS(1)*WKA(1),RS(1)*YIJ(I+NS,1,L,TAU(L))
c	print*,2*RS(1)*WKA(2),RS(2)*ZIJ(I+NS,2,L,TAU(L))

	END DO
	
	CALL SGBSV(NP,KL,KU,1,AX,LDAX,WK,BX,NP,INFO)
	IF(INFO.NE.0) THEN
	  PRINT*,"SGBSV INFO:",INFO
	  STOP
	END IF

c       check tbs
c	DO I=1,NU
c	BB0=PJ(I,1)
c	DO J=1,NS
c	 BB0=BB0+BX(J)*YIJ(I,J,1,0.0)+BX(J+NS)*ZIJ(I,J,1,0.0)
c	END DO
c	PRINT*,TBB(F,BB0)
c	END DO
 
c    Find TB at any angle

	IF(.not.FresnelORLambertian) THEN

	 N1=NP-NU
	 DO I=1,NS
	 WKA(I)=PJ(I+NS,L)+B1(L)*TAU(L)
	 DO J=1,NS
	  WKA(I)=WKA(I)+BX(N1+J)*YIJ(I+NS,J,L,TAU(L))+
     1                  BX(N1+NS+J)*ZIJ(I+NS,J,L,TAU(L))
	 END DO
	 END DO

	END IF
	  
	DO I=1,NS
	 CALL LEGENDRE(NL,UI(I),PL(0,I))
	 CALL LEGENDRE(NL,-UI(I),PL(0,I+NS))
	END DO
	CALL LEGENDRE(NL,U,PL(0,NU+1))
	CALL LEGENDRE(NL,-U,PL(0,NU+2))

c DOWNWARD

        BB0=BI0
        DO I=1,L
         OMEGA=OM(I)
         DO J=1,NS
          HH1=0
          HH2=0
          DO LL=0,NL
           GG1=0
           GG2=0
           DO M=1,NU
            GG1=GG1+A4(M)*PL(LL,M)*GIJ(M,J,I)
            GG2=GG2+A4(M)*PL(LL,M)*GIJ(IX(M),J,I)
           END DO
           HH1=HH1+GG1*AL(LL,I)*PL(LL,NU+2)
           HH2=HH2+GG2*AL(LL,I)*PL(LL,NU+2)
          END DO
          GI(J)=HH1*0.25*OMEGA/(1-K(J,I)*U)
          GI(J+NS)=HH2*0.25*OMEGA/(1+K(J,I)*U)
         END DO

	 Z0=0
	 DO LL=0,NL
	  YZ0=0
	  DO M=1,NU
	   YZ0=YZ0+A4(M)*PL(LL,M)*PJ(M,I)
	  END DO
	  Z0=Z0+YZ0*AL(LL,I)*PL(LL,NU+2)
	 END DO
	 Z0=Z0*0.5*OMEGA+(1.-OMEGA)*B0(I)

         HH=0
         TRANS=exp(-TAU(I)/U)
         DO M=1,NS
          AI=exp(-K(M,I)*TAU(I))-exp(-TAU(I)/U)
          BI=1-exp(-(K(M,I)*TAU(I)+TAU(I)/U))
          HH1=BX((I-1)*NU+M)+BX((I-1)*NU+M+NS)
          HH2=BX((I-1)*NU+M)-BX((I-1)*NU+M+NS)
          HH=AI*HH1*GI(M)+BI*HH2*GI(M+NS) + HH
         END DO
	 ZZ=(Z0-B1(I)*U)*(1-TRANS)+B1(I)*TAU(I)
         AX(1,I)=BB0*TRANS+HH+ZZ

         BB0=AX(1,I)

        END DO
c	print*,BB0

c UPWARD
	IF(FresnelORLambertian) THEN

        BB0=BB0*RSUU+(1-RSUU)*BIS

c	print*,BB0,RSUU,BIS

	ELSE

	BB0=0
	DO I=1,NS
	 BB0=BB0+WKA(I)*UI(I)*AJ(I)
	END DO
	BB0=BB0*2*RSUU+(1-RSUU)*BIS

c	print*, TBB(F,WKA(1)),TBB(F,WKA(2)),F,TBB(F,BB0),RSUU

	END IF

        DO I=L,1,-1
         OMEGA=OM(I)
         DO J=1,NS
          HH1=0
          HH2=0
          DO LL=0,NL
           GG1=0
           GG2=0
           DO M=1,NU
            GG1=GG1+A4(M)*PL(LL,M)*GIJ(M,J,I)
            GG2=GG2+A4(M)*PL(LL,M)*GIJ(IX(M),J,I)
           END DO
           HH1=HH1+GG1*AL(LL,I)*PL(LL,NU+1)
           HH2=HH2+GG2*AL(LL,I)*PL(LL,NU+1)
          END DO
          GI(J)=HH1*0.25*OMEGA/(1+K(J,I)*U)
          GI(J+NS)=HH2*0.25*OMEGA/(1-K(J,I)*U)
         END DO
 
         Z0=0
         DO LL=0,NL
          YZ0=0
          DO M=1,NU
           YZ0=YZ0+A4(M)*PL(LL,M)*PJ(M,I)
          END DO
          Z0=Z0+YZ0*AL(LL,I)*PL(LL,NU+1)
         END DO
         Z0=Z0*0.5*OMEGA+(1.-OMEGA)*B0(I)

         HH=0
         TRANS=exp(-TAU(I)/U)
         DO M=1,NS
          AI=exp(-K(M,I)*TAU(I))-exp(-TAU(I)/U)
          BI=1-exp(-(K(M,I)*TAU(I)+TAU(I)/U))
          HH1=BX((I-1)*NU+M)+BX((I-1)*NU+M+NS)
          HH2=BX((I-1)*NU+M)-BX((I-1)*NU+M+NS)
          HH=BI*HH1*GI(M)+AI*HH2*GI(M+NS) + HH
         END DO
         ZZ=(Z0+B1(I)*U)*(1-TRANS)-B1(I)*TAU(I)*TRANS
         AX(2,I)=BB0*TRANS+HH+ZZ

         BB0=AX(2,I)

        END DO
c	print*,BB0

c TBs
c upward at top AND downward at bottom of layer LOUT

 	TB(1)=TBB(F,AX(2,LOUT))
 	TB(2)=TBB(F,AX(1,LOUT))

	RETURN
	END
