C      EIGENVALUES AND EIGENVECTORS 4-STREAM
C      DOM METHOD	Liou (1974) JAS

	SUBROUTINE STRMKW(NL,W,EK,EW,AL,B0,B1,PJ)
	COMMON /strm4/AJ(2),UI(2)
	REAL EK(*),EW(4,*),BIJ(4,4),U4(4),A4(4)
	REAL AL(0:NL),PL(0:4,4),PJ(*)

	DO I=1,2
	 U4(I)=UI(I)
	 U4(I+2)=-UI(I)
	 A4(I)=AJ(I)
	 A4(I+2)=AJ(I)
	END DO

	DO I=1,4
	 CALL LEGENDRE(NL,U4(I),PL(0,I))
	END DO
	DO I=1,4
	 DO J=1,4
	  BIJ(I,J)=0
	  DO LL=0,NL
	   BIJ(I,J)=AL(LL)*PL(LL,I)*PL(LL,J) + BIJ(I,J)
	  END DO
	  BIJ(I,J)=BIJ(I,J)*W*0.5*A4(J)
	  IF(I.NE.J) THEN
	   BIJ(I,J)=BIJ(I,J)/U4(I)
	  ELSE
	   BIJ(I,J)=(BIJ(I,J)-1.)/U4(I)
	  END IF
	 END DO
	END DO

	b22p=BIJ(2,2)+BIJ(2,4)
	b22m=BIJ(2,2)-BIJ(2,4)
	b21p=BIJ(2,1)+BIJ(2,3)
	b21m=BIJ(2,1)-BIJ(2,3)
	b12p=BIJ(1,2)+BIJ(1,4)
	b12m=BIJ(1,2)-BIJ(1,4)
	b11p=BIJ(1,1)+BIJ(1,3)
	b11m=BIJ(1,1)-BIJ(1,3)
	a22=b22p*b22m+b12p*b21m
	a21=b22m*b21p+b21m*b11p
	a12=b12m*b22p+b11m*b12p
	a11=b12m*b21p+b11m*b11p

	B=a22+a11
	C=a21*a12-a11*a22
	 
	EK(1)=SQRT((B+SQRT(B*B+4*C))/2)
        EK(2)=SQRT((B-SQRT(B*B+4*C))/2)

	A1=(EK(1)**2-a22)/a21
	A2=(EK(2)**2-a22)/a21
	am=b22m*b11m-b12m*b21m

	EW(1,1)=0.5*(A1+(A1*b22m-b12m)/am*EK(1))
        EW(1,2)=0.5*(A2+(A2*b22m-b12m)/am*EK(2))
        EW(3,1)=0.5*(A1-(A1*b22m-b12m)/am*EK(1))
        EW(3,2)=0.5*(A2-(A2*b22m-b12m)/am*EK(2))
	EW(2,1)=0.5*(1+(b11m-A1*b21m)/am*EK(1))
        EW(2,2)=0.5*(1+(b11m-A2*b21m)/am*EK(2))
        EW(4,1)=0.5*(1-(b11m-A1*b21m)/am*EK(1))
        EW(4,2)=0.5*(1-(b11m-A2*b21m)/am*EK(2))

	A0=-(1.0-W)*B0
	c13p=-B1
	c13m=A0/UI(1)	
	c24p=-B1
	c24m=A0/UI(2)
	C=(c13m*b21p-c24m*b11p)/(b12p*b21p-b11p*b22p)
	D=(c13m*b22p-c24m*b12p)/(b11p*b22p-b12p*b21p)
	A=(c13p*b21m-c24p*b11m)/(b12m*b21m-b11m*b22m)
	B=(c13p*b22m-c24p*b12m)/(b11m*b22m-b12m*b21m)
	PJ(1)=D+B
	PJ(3)=D-B
	PJ(2)=C+A
	PJ(4)=C-A

	RETURN
	END
