C***********************************************************
C* Main Program for 4-stream mwrt Version 2006.5.21        *
C* Read data from files and/or command line                *
C***********************************************************
C
C          Defaults:
	INTEGER L
	DATA L/-1/			! -l
	REAL F			
	DATA F/18.9/			! -f
	INTEGER LOUT
	DATA LOUT/1/			! -lout
	INTEGER IHV	
	DATA IHV/0/			! -ihv
	REAL U
	DATA U/0.60/			! -u
	CHARACTER WTR*80,AIR*80
	DATA WTR/'.wtr'/		! -wtr
	DATA AIR/'.air'/		! -air
	REAL TS
	DATA TS/300./			! -ts
	INTEGER SURF	
	DATA SURF/0/			! -surf
	REAL SLNTY
	DATA SLNTY/35./			! -slnty
	REAL EMS
	DATA EMS/0.9/			! -surf_ems
	INTEGER ICETYPE
	DATA ICETYPE/2/			! -surf_icetype
	INTEGER SNOWTYPE
	DATA SNOWTYPE/1/		! -surf_snowtype
	REAL WIND
	DATA WIND/0.0/			! -wind
	CHARACTER*10 ICEMODEL
	DATA ICEMODEL/'midlat'/		! -icemodel
	INTEGER ICESHAPE
	DATA ICESHAPE /8/		! -iceshape
	CHARACTER*10 SNWMODEL
	DATA SNWMODEL/'SS'/		! -snowmodel
	INTEGER SNWSHAPE
	DATA SNWSHAPE/9/		! -snowshape
	REAL GRPDEN
	DATA GRPDEN/-1/			! -graupeldensity
	CHARACTER OUTFILE*80
	DATA OUTFILE/'none'/		! -outfile
	CHARACTER*10 SurfModel
	DATA SurfModel/'Fresnel'/       ! -SurfModel
	CHARACTER*10 MixingRule         
	DATA MixingRule/'MG'/           ! -MixingRule
        CHARACTER*10 RorW               
        DATA RorW/'Rate'/               ! -RorW

	CHARACTER cmd*20,what*80
	INCLUDE '../include/maxnumbers.inc'
	REAL WC(MAXL),WI(MAXL),RR(MAXL),RS(MAXL),RG(MAXL)
        REAL WR(MAXL),WS(MAXL),WG(MAXL)
        REAL PMB(MAXL+1),TK(MAXL+1),RH(MAXL+1),Z(MAXL+1)
	REAL TB(2),WK(95*MAXL)
	INTEGER IO

	IO=0
	icmd=1
 10     call getarg(icmd,cmd)
	if(cmd.eq.'') goto 100
	icmd=icmd+1
	call getarg(icmd,what)
	if(cmd.eq.'-h' .or. cmd.eq.'--help' .or. cmd.eq.'?') then
	 call hlpmwrt4
	else if(cmd.eq.'-f') then
		call rdf(what,F)
	else if(cmd.eq.'-l') then
		call rdi(what,L)
	else if(cmd.eq.'-lout') then
		call rdi(what,LOUT)
	else if(cmd.eq.'-ihv') then
		call rdi(what,IHV)
	else if(cmd.eq.'-u') then
		call rdf(what,U)
	else if(cmd.eq.'-wtr') then
		WTR=what
	else if(cmd.eq.'-air') then
		AIR=what
	else if(cmd.eq.'-ts') then
		call rdf(what,TS)
	else if(cmd.eq.'-surf') then
		call rdi(what,SURF)
	else if(cmd.eq.'-slnty') then
		call rdf(what,SLNTY)
	else if(cmd.eq.'-surf_ems') then
		call rdf(what,EMS)
	else if(cmd.eq.'-surf_icetype') then
		call rdi(what,ICETYPE)
	else if(cmd.eq.'(-surf_snowtype') then
		call rdi(what,SNOWTYPE)
	else if(cmd.eq.'-wind') then
		call rdf(what,WIND)
	else if(cmd.eq.'-icemodel') then
		ICEMODEL=what
	else if(cmd.eq.'-iceshape') then
		call rdi(what,ICESHAPE)
	else if(cmd.eq.'-snowmodel') then
		SNWMODEL=what
	else if(cmd.eq.'-snowshape') then
		call rdi(what,SNWSHAPE)
	else if(cmd.eq.'-graupeldensity') then
		call rdf(what,GRPDEN)
	else if(cmd.eq.'-outfile') then
		OUTFILE=what
	else if(cmd.eq.'-SurfModel') then
	        SurfModel=what
	else if(cmd.eq.'-MixingRule') then
	        MixingRule=what
        else if(cmd.eq.'-RorW') then
                RorW=what
	else
		icmd=icmd-1
	endif
	icmd=icmd+1
	goto 10
 100    continue
	if(SURF.eq.1) SLNTY=EMS
	if(SURF.eq.2) SLNTY=ICETYPE
	if(SURF.eq.3) SLNTY=SNOWTYPE
	open(11,file=AIR,status='old')
 	read(11,*) LP1
	if(L.gt.0) then
           L=min(L,LP1-1)
	else
	   L=LP1-1
	endif
	do i=1,L+1
	 k=L+2-i
	 read(11,*) Z(k),PMB(k),TK(k),RH(k)
	end do
	close(11)

	open(11,file=WTR,status='old')
	do i=1,L
	   k=L+1-i
           if(RorW(1:1).ne.'W') then 
	   read(11,*) WC(k),WI(k),RR(k),RS(k),RG(k)
           WR(k)=-1
           WS(k)=-1
           WG(k)=-1
           else
           read(11,*) WC(k),WI(k),WR(k),WS(k),WG(k)
           RR(k)=-1
           RS(k)=-1
           RG(k)=-1
           endif
	enddo
	close(11)

	call MWSTRM4(F,L,LOUT,IHV,U,WC,WI,RR,WR,RS,WS,RG,WG,PMB,TK,RH,Z,
     1           TS,SURF,SLNTY,WIND,ICEMODEL,ICESHAPE,SNWMODEL,SNWSHAPE,
     2           GRPDEN,MixingRule,TB,TW1,TW2,WK,SurfModel,IO)

	if(OUTFILE.EQ."none") then
	   print 333,RR(L),RS(L),RG(L),TW1,TW2,(TB(i),i=1,2)
	else
	   open(21,file=OUTFILE)
	   write(21,333) RR(L),RS(L),RG(L),TW1,TW2,TB
	   close(21)
	endif

 333    format(3f10.3,2f10.1,2f7.2)

	end
