c from .hyd file to profiles
	program getwtr
	include '../include/maxnumbers.inc'
	parameter(NN1=20)
	dimension rr(MAXL),rs(MAXL),rg(MAXL),wc(MAXL),wi(MAXL)
	dimension dr(2,NN1),zs(2,NN1),fr(NN1),fs(NN1),fg(NN1),
     1            cw(NN1),ci(NN1),z(MAXL),iz(MAXL)
	character awk*80,bwk*80,cwk*5,airfile*80,outfile*80,wki*15
	data wki/'/lib/profiles/'/
	data outfile,airfile/'.wtr','not_defined'/
	real ar(NN1),br(NN1)
	include '../include/mwrthm.inc'

	call getarg(1,awk)
	if(awk.eq.'' .or. awk.eq.'-h' .or. awk.eq.'--help') then
	   print*,"Usage: getwtr dotHYDfile PrecipRate",
     1	  " [-dw delta_lwc] [-di delta_iwc] [-mw fac_lwc] [-mi fac_iwc]", 
     2    " [-o outfile] [-a airfile]"
	   stop
	endif

	delta_lwc=0
	delta_iwc=0
	fac_lwc=1
	fac_iwc=1

 	bwk=awk
c	call mystrcat(bwk,wki)
c	call mystrcat(bwk,awk)
	
	open(71,file=bwk,status='old')
        read(71,*) awk,n1,cwk
c       print*,	awk,n1,"  ",cwk
	do i=1,n1
	read(71,*) zs(1,i),zs(2,i),dr(1,i),dr(2,i),
     1             fr(i),fs(i),fg(i),cw(i),ci(i)
c	print*,zs(1,i),zs(2,i),dr(1,i),dr(2,i),
c     1             fr(i),fs(i),fg(i),cw(i),ci(i)
	end do
	close(71)

c	print*,(fr(i),cw(i),fs(i),i=1,3)
	
	rsg0=0
	do i=1,2
	   do j=1,n1
	      if(dr(i,j).gt.rsg0) rsg0=dr(i,j)
	   enddo
	enddo
	if(rsg0.gt.0.0) then
	    do i=1,2
	       do j=1,n1
		  dr(i,j)=dr(i,j)/rsg0
	       enddo
	    enddo
	endif

	call getarg(2,bwk)
	if(bwk.eq.'') then
	   print*,"You need to specify precipitation rate."
	   stop
	endif
	call rdf(bwk,rsg0)

	i=3
 10	continue
	call getarg(i,bwk)
	if(bwk.eq.'') goto 11
	if(bwk.eq.'-o') then
	   i=i+1
	   call getarg(i,outfile)
	else if(bwk.eq.'-a') then
	   i=i+1
	   call getarg(i,bwk)
	   airfile=mwrthm
	   call mystrcat(airfile,wki)
	   call mystrcat(airfile,bwk)
	else if(bwk.eq.'-dw') then
	   i=i+1
	   call getarg(i,bwk)
	   call rdf(bwk,delta_lwc)
        else if(bwk.eq.'-di') then
           i=i+1
           call getarg(i,bwk)
           call rdf(bwk,delta_iwc)
        else if(bwk.eq.'-mw') then
           i=i+1
           call getarg(i,bwk)
           call rdf(bwk,fac_lwc)
        else if(bwk.eq.'-mi') then
           i=i+1
           call getarg(i,bwk)
           call rdf(bwk,fac_iwc)
        endif
	i=i+1
	goto 10

 11	continue
	if(airfile.eq.'not_defined') then
	   airfile=awk
	endif
		
	open(71,file=airfile,status='old')
	read(71,*) np1
	read(71,*) z0
	z0=z0*0.001
	do i=1,np1-1
	   read(71,*) z(i)
	   z(i)=z(i)*0.001
	enddo
	close(71)
	do i=1,np1-1
	   z(i)=z0+0.5*(z(i)-z0)
	   z0=z(i)
	   iz(i)=n1
	   do j=1,n1
	      if(z(i).ge.zs(1,j) .and. z(i).lt.zs(2,j)) iz(i)=j
	   enddo
	enddo

	if(cwk.eq.'LOG') then
	   do i=1,n1
	     if(dr(1,i).eq.0.0 .and. dr(2,i).eq.0.0) then
		ar(i)=0
		br(i)=0
             else if(rsg0.eq.0) then
		ar(i)=0
		br(i)=0
	     else 
		if(dr(1,i).lt.1.e-2) dr(1,i)=1.e-2
		if(dr(2,i).lt.1.e-2) dr(2,i)=1.e-2
		br(i)=log(dr(2,i)/dr(1,i))/(zs(2,i)-zs(1,i))
		ar(i)=log(rsg0*dr(1,i))-br(i)*zs(1,i)
	     endif
	   enddo
	else
	   do i=1,n1
	      br(i)=rsg0*(dr(2,i)-dr(1,i))/(zs(2,i)-zs(1,i))
	      ar(i)=rsg0*dr(1,i)-br(i)*zs(1,i)
	   enddo
	endif

c	print*,(ar(i),br(i),i=1,3)
c	print*,iz
	do i=1,np1-1
	   wc(i)=cw(iz(i))
	   wi(i)=ci(iz(i))
	   if(wc(i).ge.0.0) then
		wc(i)=(wc(i)+delta_lwc)*fac_lwc
	   else
		wc(i)=0
	   endif
           if(wi(i).ge.0.0) then
                wi(i)=(wi(i)+delta_iwc)*fac_iwc
           else
                wi(i)=0
           endif
	   if(rsg0.eq.0) then
	      rr(i)=0
	      rs(i)=0
	      rg(i)=0
	   else if(ar(iz(i)).eq.0.0 .and. br(iz(i)).eq.0.0) then
	      rr(i)=0
	      rs(i)=0
	      rg(i)=0
	   else
	      if(cwk.eq.'LOG') then
		 rt=exp(ar(iz(i))+br(iz(i))*z(i))
	      else
		 rt=ar(iz(i))+br(iz(i))*z(i)
	      endif
	      rr(i)=rt*fr(iz(i))
	      rs(i)=rt*fs(iz(i))
	      rg(i)=rt*fg(iz(i))
	   endif
        enddo

	open(71,file=outfile)
	do i=1,np1-1
	 write(71,200) wc(i),wi(i),rr(i),rs(i),rg(i)
	end do
	close(71)

 200    format(5f10.2)

	end
