#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NL 200

float es(float);
float sdfromrh( float, float, float);
float rhfromsd(float, float, float);

int main(int argc, char **argv) {
	float z[NL],rh[NL],p[NL],t[NL];
	float ap,at,arh,awk;
	int layer;
	char fn[80],ff[80];
	int i;
	FILE *fp;

        if (argc == 1) 
	  strcpy(fn,".air");
	else 
          if ( (!strcmp(argv[1],"-h")) || (!strcmp(argv[1],"--help"))) {
		fprintf(stderr,"Usage: getpw [air_file]");
		exit (0);
	  }
          else 
      	     	strcpy(fn,argv[1]);
 

	if (!(fp=fopen(fn,"r"))) {
		fprintf(stderr,"FILE %s does not exist.\n",fn);
		exit (1);
	}
	fgets(ff,sizeof(ff),fp);
	sscanf(ff,"%d",&layer);
	if (layer>NL) {
		fprintf(stderr,"Layer Number (%d) exceeds %d.\n",layer,NL);
		exit (1);
	}
	for (i=0;i<layer;i++)  
		fscanf(fp,"%f %f %f %f",&z[i],&p[i],&t[i],&rh[i]);
	fclose(fp);

	
	awk = 0.;
	for (i=0;i<layer-1;i++) {
		ap = 0.5*(p[i]+p[i+1]);
		at = 0.5*(t[i]+t[i+1]);
		arh = 0.5*(rh[i]+rh[i+1]);
		awk=awk+(z[i+1]-z[i])*sdfromrh(ap,at,arh)*0.001;
	}

	printf("%f",awk);
}
