#include <math.h>

/*   exchange water vapor related physical variables */
/* NAME       VARIABLE        			UNITS
   p	     pressure	       			mb
   t         temperature       			K
   rh        relative humidity 			%
   es        saturate vapor pressure to water   mb
*/

float es(float t) {
	return (float)(6.10779*exp(17.28*(t-273.15)/(t-36.)));
}

float sdfromrh(float p, float t, float rh) {
	float rou,e;
	rou = p/2.87/t;
	e = es(t);
	return (float)(622.*e/(p-e)*rh*0.01*rou);
}

float rhfromsd(float p, float t, float sd) {
	float rou, e;
	rou = p/2.87/t;
	e = es(t);
	return (float)(sd/622./e*(p-e)/rou*100.);
}

